searchNodes=[{"doc":"Terminus allows you to crawl and subscribe to Bitcoin transaction events using Bitbus and Bitsocket, and download binary data from BitFS. terminus &mdash; noun the end of a railway or other transport route, or a station at such a point; a terminal. a final point in space or time; an end or extremity. Terminus provides a single unified interface for crawling and querying Bitbus, Bitsocket and BitFS in a highly performant manner. Each request is a GenStage process, enabling you to create powerful concurrent data flows. Terminus may well be the most powerful way of querying Bitcoin in the Universe! Apis Terminus can be used to interface with the following Planaria Corp APIs. Bitbus - crawl filtered subsets of confirmed Bitcoin transactions in blocks. Bitsocket - subscribe to a live, filterable stream of realtime transaction events. BitFS - fetch raw binary data chunks (over 512kb) indexed from all Bitcoin transactions. Authentication Both Bitbus and Bitsocket require a token to authenticate requests. (The Bitsocket listen API currently doesn&#39;t require a token but that is likely to change). Currently tokens are free with no usage limits. (Also likely to change) Get your Planaria Token. Query language Both Bitbus and Bitsocket use the same MongoDB-like query language, known as Bitquery. Terminus allows the optional use of shorthand queries (just the q value). iex&gt; Terminus.Bitbus.fetch!(%{ ...&gt; find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; }, ...&gt; sort: %{ &quot;blk.i&quot;: -1 }, ...&gt; project: %{ &quot;tx.h&quot;: 1 }, ...&gt; limit: 5 ...&gt; }, token: token) [ %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;79ae3ca23d1067b9ab45aba7e8ff4de1943e383e9a33e562d5ffd8489f388c93&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;5526989417f28da5e0c99b58863db58c1faf8862ac9325dc415ad4b11605c1b1&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;0bac587681360f961dbccba4c49a5c8f1b6f0bef61fe8501a28dcfe981a920b5&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fa13a8f0f5688f761b2f34949bb35fa5d6fd14cb3d49c2c1617363b6984df162&quot;}} ] Using Terminus Terminus can be used as a simple client for crawling and querying Bitbus and Bitsocket APIs, and fetching binary data from BitFS. For simple examples, refer to the Terminus.Bitbus, Terminus.Bitsocket and Terminus.BitFS documentation. Streams Most Terminus functions return a streaming Enumerable.t/0 allowing you to compose data processing pipelines and operations. iex&gt; Terminus.Bitbus.crawl!(query, token: token) ...&gt; |&gt; Stream.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Stream.each(&amp;save_to_db/1) ...&gt; |&gt; Stream.run :ok Concurrency Under the hood, each Terminus request is a GenStage producer process, and the bare pid can be returned. This allows you to take full advantage of Elixir&#39;s concurrency, by either using with your own GenStage consumers or using a tool like Flow to create powerful concurrent pipelines. # One stream of transactions will be distributed across eight concurrent # processes for mapping and saving the data. iex&gt; {:ok, pid} = Terminus.Bitbus.crawl(query, token: token, stage: true) iex&gt; Flow.from_stages([pid], stages: 8) ...&gt; |&gt; Flow.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Flow.map(&amp;save_to_db/1) ...&gt; |&gt; Flow.run :ok","ref":"Terminus.html","title":"Terminus","type":"module"},{"doc":"Module for interfacing with the BitFS API. BitFS crawls the Bitcoin blockchain to find and store all the bitcoin script pushdata chunks larger than 512 bytes. BitFS is an autonomous file system constructed from Bitcoin transactions. BitFS URI scheme Files are referenced using the BitFS URI scheme. # bitfs://&lt;TRANSACTION_ID&gt;.(in|out).&lt;SCRIPT_INDEX&gt;.&lt;CHUNK_INDEX&gt; &quot;bitfs://13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot; Terminus accepts given BitFS URI strings with or without the bitfs:// prefix. Usage To simply return the binary data for any BitFS URI use fetch/2. iex&gt; Terminus.BitFS.fetch(uri) {:ok, &lt;&lt;...&gt;&gt;} It is also possible to scan entire transactions and automatically fetch the binary data for any BitFS URIs discovered in the transaction. The binary data is added to the same output script at the same index with a d prefixed attribute. iex&gt; tx = %{ ...&gt; &quot;out&quot; =&gt; [%{ ...&gt; &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, ...&gt; ... ...&gt; }] ...&gt; } iex&gt; Terminus.BitFS.scan_tx(tx) %{ &quot;out&quot; =&gt; [%{ &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, &quot;d4&quot; =&gt; &lt;&lt;...&gt;&gt;, ... }] }","ref":"Terminus.BitFS.html","title":"Terminus.BitFS","type":"module"},{"doc":"Fetches the binary blob data from BitFS using the given BitFS URI. Returns the result in an :ok / :error tuple pair. By default the entire data response is returned, although optionally a streaming Enumerable.t/0 can be returned or a linked GenStage pid. Options The accepted options are: stream - Return a streaming Enumerable.t/0. Defaults to false. stage - Return a linked GenStage pid. Defaults to false. Examples Files are references using the BitFS URI scheme. # &lt;TRANSACTION_ID&gt;.(in|out).&lt;SCRIPT_INDEX&gt;.&lt;CHUNK_INDEX&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot; By default Terminus.BitFS.fetch/2 returns the binary data of the file. iex&gt; Terminus.BitFS.fetch(uri) {:ok, &lt;&lt;...&gt;&gt;} Optionally a streaming Enumerable.t/0 can be returned. iex&gt; Terminus.BitFS.fetch(uri, stream: true) {:ok, %Stream{}} Or the pid of the GenStage producer can be returned. iex&gt; Terminus.BitFS.fetch(uri, stage: true) {:ok, #PID&lt;&gt;}","ref":"Terminus.BitFS.html#fetch/2","title":"Terminus.BitFS.fetch/2","type":"function"},{"doc":"As fetch/2 but returns the result or raises an exception if it fails.","ref":"Terminus.BitFS.html#fetch!/2","title":"Terminus.BitFS.fetch!/2","type":"function"},{"doc":"Scans the given transaction script map and fetches the data for any BitFS URI references. Where a BitFS reference is found, the data is fetched and added to the same script at the same index as the reference.","ref":"Terminus.BitFS.html#scan_script/1","title":"Terminus.BitFS.scan_script/1","type":"function"},{"doc":"Scans the given transaction map and fetches the data for any BitFS URI references. Where a BitFS reference is found, the data is fetched and added to the same script at the same index as the reference. For example, if a BitFS reference is found at f4, that a new attribute d4 is added to the same script. Examples iex&gt; tx = %{ ...&gt; &quot;out&quot; =&gt; [%{ ...&gt; &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, ...&gt; ... ...&gt; }] ...&gt; } iex&gt; Terminus.BitFS.scan_tx(tx) %{ &quot;out&quot; =&gt; [%{ &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, &quot;d4&quot; =&gt; &lt;&lt;...&gt;&gt;, ... }] }","ref":"Terminus.BitFS.html#scan_tx/1","title":"Terminus.BitFS.scan_tx/1","type":"function"},{"doc":"Module for interfacing with the Bitbus API. Bitbus is a powerful API that allows you to crawl a filtered subset of the Bitcoin blockchain. Bitbus indexes blocks, thus can be used to crawl confirmed transactions. We run a highly efficient bitcoin crawler which indexes the bitcoin blockchain. Then we expose the index as an API so anyone can easily crawl ONLY the subset of bitcoin by crawling bitbus. Schema Bitbus transaction documents have the following schema: %{ &quot;_id&quot; =&gt; &quot;...&quot;, # Bitbus document ID &quot;blk&quot; =&gt; %{ &quot;h&quot; =&gt; &quot;...&quot;, # Block hash &quot;i&quot; =&gt; int, # Block height &quot;t&quot; =&gt; int, # Block timestamp }, &quot;in&quot; =&gt; [...], # List of inputs &quot;lock&quot; =&gt; int, # Lock time &quot;out&quot; =&gt; [...], # List of outputs &quot;tx&quot; =&gt; %{ &quot;h&quot; =&gt; &quot;...&quot; # Transaction hash } } Transactions inputs and outputs are represented using the TXO schema. Usage For smaller queries of limited results, fetch/2 can be used to return a list of transactions: iex&gt; Terminus.Bitbus.fetch(%{ ...&gt; find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; }, ...&gt; sort: %{ &quot;blk.i&quot;: -1 }, ...&gt; limit: 5 ...&gt; }, token: token) {:ok, [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}, ... }, ... ]} For larger crawl operations, use crawl/3 to stream results into your own data processing pipeline. iex&gt; Terminus.Bitbus.crawl!(query, token: token) ...&gt; |&gt; Stream.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Stream.each(&amp;save_to_db/1) ...&gt; |&gt; Stream.run :ok","ref":"Terminus.Bitbus.html","title":"Terminus.Bitbus","type":"module"},{"doc":"Crawls Bitbus for transactions using the given query and returns a stream. Returns the result in an :ok / :error tuple pair. All requests must provide a valid Planaria token. By default a streaming Enumerable.t/0 is returned. Optionally a linked GenStage pid can be returned for using in combination with your own GenStage consumer. If a callback is provided, the stream is automatically run and the callback is called on each transaction. Options The accepted options are: token - Planaria authentication token. Required. host - The Bitbus host. Defaults to txo.bitbus.network. stage - Return a linked GenStage pid. Defaults to false. Examples Queries should be in the form of any valid Bitquery. query = %{ find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; } } By default Terminus.Bitbus.crawl/3 returns a streaming Enumerable.t/0. iex&gt; Terminus.Bitbus.crawl(query, token: token) {:ok, %Stream{}} Optionally the pid of the GenStage producer can be returned. iex&gt; Terminus.Bitbus.crawl(query, token: token, stage: true) {:ok, #PID&lt;&gt;} If a callback is provided, the function returns :ok and the callback is called on each transaction. iex&gt; Terminus.Bitbus.crawl(query, [token: token], fn tx -&gt; ...&gt; IO.inspect tx ...&gt; end) :ok","ref":"Terminus.Bitbus.html#crawl/3","title":"Terminus.Bitbus.crawl/3","type":"function"},{"doc":"As crawl/3 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitbus.html#crawl!/3","title":"Terminus.Bitbus.crawl!/3","type":"function"},{"doc":"Crawls Bitbus for transactions using the given query and returns a list of transactions. Returns the result in an :ok / :error tuple pair. This function is suitable for smaller limited queries as the entire result set is loaded in to memory an returned. For large crawls, crawl/3 is preferred as the results can be streamed and processed more efficiently. Options The accepted options are: token - Planaria authentication token. Required. host - The Bitbus host. Defaults to txo.bitbus.network. Examples iex&gt; Terminus.Bitbus.fetch(query, token: token) {:ok, [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;bbae7aa467cb34010c52033691f6688e00d9781b2d24620cab51827cd517afb8&quot;}, ... }, ... ]}","ref":"Terminus.Bitbus.html#fetch/2","title":"Terminus.Bitbus.fetch/2","type":"function"},{"doc":"As fetch/2 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitbus.html#fetch!/2","title":"Terminus.Bitbus.fetch!/2","type":"function"},{"doc":"Fetches and returns the current status of Bitbus. Returns the result in an :ok / :error tuple pair. The returned map of data includes the current block header as well as the total number of transactions in the block (count). Examples iex&gt; Terminus.Bitbus.status {:ok, %{ &quot;hash&quot; =&gt; &quot;00000000000000000249f9bd0e127ebc62125a72686a7470fe4a41e4add2deb1&quot;, &quot;prevHash&quot; =&gt; &quot;000000000000000001b3ea9c4c073226c6233583ab510ea10ce01faff17c89f3&quot;, &quot;merkleRoot&quot; =&gt; &quot;fb19b1ff5cd838cfca399f9f2e46fa3a0e9f0da0459f91bfd6d02a75756f3a4d&quot;, &quot;time&quot; =&gt; 1586457301, &quot;bits&quot; =&gt; 402821143, &quot;nonce&quot; =&gt; 1471454449, &quot;height&quot; =&gt; 629967, &quot;count&quot; =&gt; 2193 }}","ref":"Terminus.Bitbus.html#status/1","title":"Terminus.Bitbus.status/1","type":"function"},{"doc":"As status/1 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitbus.html#status!/1","title":"Terminus.Bitbus.status!/1","type":"function"},{"doc":"Module for interfacing with the Bitsocket API. Bitsocket sends you realtime events from the Bitcoin blockchain. It uses Server Sent Events to stream new unconfirmed transactions as soon as they appear on the Bitcoin network. Bitsocket is like Websocket, but for Bitcoin. With just a single Bitsocket connection, you get access to a live, filterable stream of all transaction events across the entire bitcoin peer network. Schema Realtime transactions have a similar schema to Bitbus documents. However, as these are unconfirmed transactions, they have no blk infomation and provide a timestamp attribute reflecting when Bitsocket first saw the transaction. %{ &quot;_id&quot; =&gt; &quot;...&quot;, # Bitbus document ID &quot;in&quot; =&gt; [...], # List of inputs &quot;lock&quot; =&gt; int, # Lock time &quot;out&quot; =&gt; [...], # List of outputs &quot;timestamp&quot; =&gt; int, # Timestamp of when tx seen &quot;tx&quot; =&gt; %{ &quot;h&quot; =&gt; &quot;...&quot; # Transaction hash } } Bitsocket offers alternative endpoints for querying documents with inputs and outputs represented using either the TXO schema OR the BOB schema. Terminus defaults to using the TXO endpoint, but the BOB endpoint can be used by specifying the :host option. Terminus.Bitsocket.listen(query, host: &#39;bob.bitsocket.network&#39;) Usage Subscribe to realtime Bitcoin transactions using listen/3 and stream the results into your own data processing pipeline. iex&gt; Terminus.Bitsocket.listen!(query) ...&gt; |&gt; Stream.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Stream.each(&amp;save_to_db/1) ...&gt; |&gt; Stream.run :ok Bitsocket also provides an API for querying and crawling the transaction event database which indexes all transactions in the previous 24 hours. Both crawl/3 and fetch/2 can be used to query these events. iex&gt; Terminus.Bitsocket.fetch(%{ ...&gt; find: %{ ...&gt; &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot;, ...&gt; &quot;timestamp&quot; =&gt; %{&quot;$gt&quot;: :os.system_time(:millisecond) - 60000} ...&gt; }, ...&gt; sort: %{ &quot;timestamp&quot;: -1 } ...&gt; }, token: token) {:ok, [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}, ... }, ... ]}","ref":"Terminus.Bitsocket.html","title":"Terminus.Bitsocket","type":"module"},{"doc":"Crawls the Bitsocket event database for transactions using the given query and returns a stream. Returns the result in an :ok / :error tuple pair. All requests must provide a valid Planaria token. By default a streaming Enumerable.t/0 is returned. Optionally a linked GenStage pid can be returned for using in combination with your own GenStage consumer. If a callback is provided, the stream is automatically run and the callback is called on each transaction. Options The accepted options are: token - Planaria authentication token. Required. host - The Bitsocket host. Defaults to txo.bitsocket.network. stage - Return a linked GenStage pid. Defaults to false. Examples Queries should be in the form of any valid Bitquery. query = %{ find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; } } By default Terminus.Bitsocket.crawl/2 returns a streaming Enumerable.t/0. iex&gt; Terminus.Bitsocket.crawl(query, token: token) {:ok, %Stream{}} Optionally the pid of the GenStage producer can be returned. iex&gt; Terminus.Bitsocket.crawl(query, token: token, stage: true) {:ok, #PID&lt;&gt;} If a callback is provided, the function returns :ok and the callback is called on each transaction. iex&gt; Terminus.Bitsocket.crawl(query, [token: token], fn tx -&gt; ...&gt; IO.inspect tx ...&gt; end) :ok","ref":"Terminus.Bitsocket.html#crawl/3","title":"Terminus.Bitsocket.crawl/3","type":"function"},{"doc":"As crawl/3 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitsocket.html#crawl!/3","title":"Terminus.Bitsocket.crawl!/3","type":"function"},{"doc":"Crawls the Bitsocket event database for transactions using the given query and returns a stream. Returns the result in an :ok / :error tuple pair. This function is suitable for smaller limited queries as the entire result set is loaded in to memory an returned. For large crawls, crawl/3 is preferred as the results can be streamed and processed more efficiently. Options The accepted options are: token - Planaria authentication token. Required. host - The Bitsocket host. Defaults to txo.bitsocket.network. Examples iex&gt; Terminus.Bitsocket.fetch(query, token: token) [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;bbae7aa467cb34010c52033691f6688e00d9781b2d24620cab51827cd517afb8&quot;}, ... }, ... ]","ref":"Terminus.Bitsocket.html#fetch/2","title":"Terminus.Bitsocket.fetch/2","type":"function"},{"doc":"As fetch/2 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitsocket.html#fetch!/2","title":"Terminus.Bitsocket.fetch!/2","type":"function"},{"doc":"Subscribes to Bitsocket and streams realtime transaction events using the given query. Returns the result in an :ok / :error tuple pair. By default a streaming Enumerable.t/0 is returned. Optionally a linked GenStage pid can be returned for using in combination with your own GenStage consumer. If a callback is provided, the stream is automatically run and the callback is called on each transaction. As Bitsocket streams transactions using Server Sent Events, the stream will stay open (and blocking) permanently. This is best managed inside a long-running Elixir process. Options The accepted options are: host - The Bitsocket host. Defaults to txo.bitsocket.network. stage - Return a linked GenStage pid instead of a stream. Examples Queries should be in the form of any valid Bitquery. query = %{ find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; } } By default Terminus.Bitsocket.listen/2 returns a streaming Enumerable.t/0. iex&gt; Terminus.Bitsocket.listen(query, token: token) {:ok, %Stream{}} Optionally the pid of the GenStage producer can be returned. iex&gt; Terminus.Bitsocket.listen(query, token: token, stage: true) {:ok, #PID&lt;&gt;} If a callback is provided, the stream returns :ok and the callback is called on each transaction. iex&gt; Terminus.Bitsocket.listen(query, [token: token], fn tx -&gt; ...&gt; IO.inspect tx ...&gt; end) :ok","ref":"Terminus.Bitsocket.html#listen/3","title":"Terminus.Bitsocket.listen/3","type":"function"},{"doc":"As listen/3 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitsocket.html#listen!/2","title":"Terminus.Bitsocket.listen!/2","type":"function"},{"doc":"A behaviour module for implementing Planaria-like state machines in Elixir. A module using Terminus.Planaria is a GenStage consumer process that will automatically mangage its own producer processes to crawl and listen to Bitcoin transaction events. Developers only need to implement callback functions to handle transaction events. Example The following code demonstrates how a Twetch scraper can be built in a few lines of code. defmodule TwetchScraper do @query %{ &quot;find&quot; =&gt; %{ &quot;out.s2&quot;: &quot;19HxigV4QyBv3tHpQVcUEQyq1pzZVdoAut&quot;, &quot;out.s25&quot;: &quot;twetch&quot; } } use Terminus.Planaria, token: Application.get_env(:my_app, :token), from: 600000, query: @query def handle_data(:block, txns) do # Handle confirmed transactions end def handle_data(:mempool, txns) do # Handle unconfirmed transactions end end The handle_data/2 callback can be implemented for each tx_event, and is typically be used to persist required data from each transaction. The handle_tape/2 callback can also be implemented for loading and persisting the tape head so a re-crawl isn&#39;t necessary if the process is interrupted. Options When invoking use Terminus.Planaria, the following config options are accepted: :token - Planaria Token. Required. :from - The block height from which to crawl for transactions. Required. :query - Full or shorthand Bitquery map. :poll - Interval (in seconds) to poll Bitbus for new blocks. Defaults to 300 (5 minutes). Supervision Each Terminus.Planaria will most commonly be started under your application&#39;s supervision tree. When you invoke use Terminus.Planaria, it automatically defines a child_spec/1 function so your Planaria modules can be started directly under a supervisor. And this is where we can have some fun and take full advantage of Elixir&#39;s concurrency model. Why not run many Planarias concurrently in your app? children = [ TwetchScraper, PreevScraper, WeathersvScraper ] Supervisor.start_link(children, strategy: :one_for_all)","ref":"Terminus.Planaria.html","title":"Terminus.Planaria","type":"behaviour"},{"doc":"Invoked for each new transaction seen by the Planaria. This is the main callback you will need to implement for your Planaria module. Typically it will be used to pull the necessary data from each transaction event and store it to a local database. When an unconfirmed transaction is seen the callback is invoked with the tx_event of :mempool. For each confirmed transaction, the callback is invoked with the tx_event of :block. The callback can return any value. Examples def handle_data(:block, txns) do txns |&gt; Enum.map(&amp;MyApp.Transaction.build/1) |&gt; Repo.insert(on_conflict: :replace_all, conflict_target: :txid) end def handle_data(:mempool, txns) do txns |&gt; Enum.map(&amp;MyApp.Transaction.build/1) |&gt; Repo.insert end","ref":"Terminus.Planaria.html#c:handle_data/2","title":"Terminus.Planaria.handle_data/2","type":"callback"},{"doc":"Invoked when a Planaria starts and also after each crawl of new blocks. This callback can be used to load and persist the tape head so a re-crawl isn&#39;t necessary if the process is interrupted. When a Planaria starts the callback is invoked with the tape_event of :start. This provides an oppurtunity to load the current :head of the tape from a database and update the given tape. The callback must return {:ok, tape}. After each crawl of block data the callback in invoked with the tape_event if :block. This allows us to store the tape :head. In this case any return value is acceptable. Examples Load the :head from a database when the Planaria starts. def handle_tape(:start, tape) do tape = case MyApp.Config.get(&quot;tape_head&quot;) do {:ok, head} -&gt; put_in(tape.head, head) _ -&gt; tape end {:ok, tape} end Persist the :head after each crawl of new blocks. def handle_tape(:block, tape) do MyApp.Config.put(&quot;tape_head&quot;, tape.head) end","ref":"Terminus.Planaria.html#c:handle_tape/2","title":"Terminus.Planaria.handle_tape/2","type":"callback"},{"doc":"Starts a Terminus.Planaria process without links (outside of a supervision tree). See start_link/3 for more information.","ref":"Terminus.Planaria.html#start/3","title":"Terminus.Planaria.start/3","type":"function"},{"doc":"Starts a Terminus.Planaria process linked to the current process. This is often used to start the Planaria as part of a supervision tree.","ref":"Terminus.Planaria.html#start_link/3","title":"Terminus.Planaria.start_link/3","type":"function"},{"doc":"Planaria config.","ref":"Terminus.Planaria.html#t:config/0","title":"Terminus.Planaria.config/0","type":"type"},{"doc":"Planaria state.","ref":"Terminus.Planaria.html#t:t/0","title":"Terminus.Planaria.t/0","type":"type"},{"doc":"Planaria tape.","ref":"Terminus.Planaria.html#t:tape/0","title":"Terminus.Planaria.tape/0","type":"type"},{"doc":"Planaria tape event.","ref":"Terminus.Planaria.html#t:tape_event/0","title":"Terminus.Planaria.tape_event/0","type":"type"},{"doc":"Planaria transaction event.","ref":"Terminus.Planaria.html#t:tx_event/0","title":"Terminus.Planaria.tx_event/0","type":"type"},{"doc":"Module for reducing data chunks from streaming HTTP requests into structured data messages.","ref":"Terminus.Chunker.html","title":"Terminus.Chunker","type":"module"},{"doc":"Handles the conversion of the given binary data chunk into a list of one or more structured types. Returns a tuple containing a list of events and a binary of any remaining data. Examples iex&gt; &quot;{\\&quot;foo\\&quot;:\\&quot;bar\\&quot;}\\n{\\&quot;foo\\&quot;:\\&quot;bar\\&quot;}\\n{\\&quot;fo&quot; ...&gt; |&gt; Terminus.Chunker.handle_chunk(:ndjson) {[%{&quot;foo&quot; =&gt; &quot;bar&quot;}, %{&quot;foo&quot; =&gt; &quot;bar&quot;}], &quot;{\\&quot;fo&quot;}","ref":"Terminus.Chunker.html#handle_chunk/2","title":"Terminus.Chunker.handle_chunk/2","type":"function"},{"doc":"A GenStage producer module for creating streaming HTTP requests. Each request is a GenStage process, enabling creating powerful concurrent data flows. Usage # Create the connection process iex&gt; Terminus.Request.connect(:https, host, 443) {:ok, pid} # Begin a request iex&gt; Terminus.Request.request(pid, &quot;GET&quot;, path, headers, body) :ok # Stream the result iex&gt; GenStage.stream([{pid, cancel: :transient}]) %Stream{}","ref":"Terminus.Request.html","title":"Terminus.Request","type":"module"},{"doc":"Creates a new connection to a given server and returns a GenStage pid.","ref":"Terminus.Request.html#connect/4","title":"Terminus.Request.connect/4","type":"function"},{"doc":"Sends a request to the connected server. The function is asynchronous and returns :ok. The GenStage pid can be subscribed to to listen to streaming data chunks.","ref":"Terminus.Request.html#request/6","title":"Terminus.Request.request/6","type":"function"},{"doc":"Streaming HTTP request state","ref":"Terminus.Request.html#t:t/0","title":"Terminus.Request.t/0","type":"type"},{"doc":"A mixin module providing functions for creating streaming HTTP requests. Examples defmodule BitFS do use Terminus.Streamer, host: &quot;x.bitfs.network&quot; def load_file(path) do case stream(&quot;GET&quot;, path, nil) do {:ok, stream} -&gt; stream |&gt; Enum.to_list |&gt; Enum.join {:error, reason} -&gt; raise reason end end end","ref":"Terminus.Streamer.html","title":"Terminus.Streamer","type":"module"},{"doc":"Runs the given streaming Enumerable.t/0 and executes the callback on each element of the stream. If the given callback is nil then the stream is passed through and returned.","ref":"Terminus.Streamer.html#handle_callback/2","title":"Terminus.Streamer.handle_callback/2","type":"function"},{"doc":"Normalizes the given Bitquery, automatically expanding shorthand queries. Examples iex&gt; normalize_query(%{find: %{&quot;tx.h&quot; =&gt; &quot;abc&quot;}}) %{ v: 3, q: %{ find: %{ &quot;tx.h&quot; =&gt; &quot;abc&quot; } } }","ref":"Terminus.Streamer.html#normalize_query/1","title":"Terminus.Streamer.normalize_query/1","type":"function"},{"doc":"Opens a HTTP connection and begins a request, returning the GenStage pid of the request. Returns the result in an :ok / :error tuple pair.","ref":"Terminus.Streamer.html#request/5","title":"Terminus.Streamer.request/5","type":"function"},{"doc":"Opens a HTTP connection and begins a request, returning a streaming Enumerable.t/0. Returns the result in an :ok / :error tuple pair.","ref":"Terminus.Streamer.html#stream/5","title":"Terminus.Streamer.stream/5","type":"function"},{"doc":"On-data callback function.","ref":"Terminus.Streamer.html#t:callback/0","title":"Terminus.Streamer.callback/0","type":"type"}]